/*******************************************************************************
* File Name: LCD_test_PM.c
* Version 1.60
*
* Description:
*  This file provides the API source code for the Static Segment LCD component.
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "LCD_test.h"


void LCD_test_SaveConfig(void) ;
void LCD_test_RestoreConfig(void) ;
extern void LCD_test_Enable(void) ;

static LCD_test_BACKUP_STRUCT LCD_test_backup;

extern uint8 LCD_test_enableState;


/*******************************************************************************
* Function Name: LCD_test_SaveConfig
********************************************************************************
*
* Summary:
*  Does nothing, provided for consistency.
*
* Parameters:
*  None.
*
* Return:
*  None.
*
*******************************************************************************/
void LCD_test_SaveConfig(void) 
{
}


/*******************************************************************************
* Function Name: LCD_test_RestoreConfig
********************************************************************************
*
* Summary:
*  Does nothing, provided for consistency.
*
* Parameters:
*  None.
*
* Return:
*  None.
*
*******************************************************************************/
void LCD_test_RestoreConfig(void) 
{
}


/*******************************************************************************
* Function Name: LCD_test_Sleep
********************************************************************************
*
* Summary:
*  Prepares component for entering the sleep mode.
*
* Parameters:
*  None.
*
* Return:
*  None.
*
* Reentrant:
*  No.
*
*******************************************************************************/
void LCD_test_Sleep(void) 
{
    LCD_test_backup.enableState = LCD_test_enableState;
    LCD_test_SaveConfig();
    LCD_test_Stop();
}


/*******************************************************************************
* Function Name: LCD_test_Wakeup
********************************************************************************
*
* Summary:
*  Wakes component from sleep mode. Configures DMA and enables the component for
*  normal operation.
*
* Parameters:
*  LCD_test_enableState - Global variable.
*
* Return:
*  Status one of standard status for PSoC3 Component
*       CYRET_SUCCESS - Function completed successfully.
*       CYRET_LOCKED - The object was locked, already in use. Some of TDs or
*                      a channel already in use.
*
* Reentrant:
*  No.
*
*******************************************************************************/
void LCD_test_Wakeup(void) 
{
    LCD_test_RestoreConfig();

    if(LCD_test_backup.enableState == 1u)
    {
        LCD_test_Enable();
    }
}


/* [] END OF FILE */
