/*******************************************************************************
* File Name: PGA_Output2.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_PGA_Output2_H) /* Pins PGA_Output2_H */
#define CY_PINS_PGA_Output2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PGA_Output2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PGA_Output2_Write(uint8 value) ;
void    PGA_Output2_SetDriveMode(uint8 mode) ;
uint8   PGA_Output2_ReadDataReg(void) ;
uint8   PGA_Output2_Read(void) ;
uint8   PGA_Output2_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PGA_Output2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PGA_Output2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PGA_Output2_DM_RES_UP          PIN_DM_RES_UP
#define PGA_Output2_DM_RES_DWN         PIN_DM_RES_DWN
#define PGA_Output2_DM_OD_LO           PIN_DM_OD_LO
#define PGA_Output2_DM_OD_HI           PIN_DM_OD_HI
#define PGA_Output2_DM_STRONG          PIN_DM_STRONG
#define PGA_Output2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PGA_Output2_MASK               PGA_Output2__MASK
#define PGA_Output2_SHIFT              PGA_Output2__SHIFT
#define PGA_Output2_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PGA_Output2_PS                     (* (reg8 *) PGA_Output2__PS)
/* Data Register */
#define PGA_Output2_DR                     (* (reg8 *) PGA_Output2__DR)
/* Port Number */
#define PGA_Output2_PRT_NUM                (* (reg8 *) PGA_Output2__PRT) 
/* Connect to Analog Globals */                                                  
#define PGA_Output2_AG                     (* (reg8 *) PGA_Output2__AG)                       
/* Analog MUX bux enable */
#define PGA_Output2_AMUX                   (* (reg8 *) PGA_Output2__AMUX) 
/* Bidirectional Enable */                                                        
#define PGA_Output2_BIE                    (* (reg8 *) PGA_Output2__BIE)
/* Bit-mask for Aliased Register Access */
#define PGA_Output2_BIT_MASK               (* (reg8 *) PGA_Output2__BIT_MASK)
/* Bypass Enable */
#define PGA_Output2_BYP                    (* (reg8 *) PGA_Output2__BYP)
/* Port wide control signals */                                                   
#define PGA_Output2_CTL                    (* (reg8 *) PGA_Output2__CTL)
/* Drive Modes */
#define PGA_Output2_DM0                    (* (reg8 *) PGA_Output2__DM0) 
#define PGA_Output2_DM1                    (* (reg8 *) PGA_Output2__DM1)
#define PGA_Output2_DM2                    (* (reg8 *) PGA_Output2__DM2) 
/* Input Buffer Disable Override */
#define PGA_Output2_INP_DIS                (* (reg8 *) PGA_Output2__INP_DIS)
/* LCD Common or Segment Drive */
#define PGA_Output2_LCD_COM_SEG            (* (reg8 *) PGA_Output2__LCD_COM_SEG)
/* Enable Segment LCD */
#define PGA_Output2_LCD_EN                 (* (reg8 *) PGA_Output2__LCD_EN)
/* Slew Rate Control */
#define PGA_Output2_SLW                    (* (reg8 *) PGA_Output2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PGA_Output2_PRTDSI__CAPS_SEL       (* (reg8 *) PGA_Output2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PGA_Output2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PGA_Output2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PGA_Output2_PRTDSI__OE_SEL0        (* (reg8 *) PGA_Output2__PRTDSI__OE_SEL0) 
#define PGA_Output2_PRTDSI__OE_SEL1        (* (reg8 *) PGA_Output2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PGA_Output2_PRTDSI__OUT_SEL0       (* (reg8 *) PGA_Output2__PRTDSI__OUT_SEL0) 
#define PGA_Output2_PRTDSI__OUT_SEL1       (* (reg8 *) PGA_Output2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PGA_Output2_PRTDSI__SYNC_OUT       (* (reg8 *) PGA_Output2__PRTDSI__SYNC_OUT) 


#if defined(PGA_Output2__INTSTAT)  /* Interrupt Registers */

    #define PGA_Output2_INTSTAT                (* (reg8 *) PGA_Output2__INTSTAT)
    #define PGA_Output2_SNAP                   (* (reg8 *) PGA_Output2__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PGA_Output2_H */


/* [] END OF FILE */
