/*******************************************************************************
* File Name: PGA_input.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_PGA_input_H) /* Pins PGA_input_H */
#define CY_PINS_PGA_input_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PGA_input_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PGA_input_Write(uint8 value) ;
void    PGA_input_SetDriveMode(uint8 mode) ;
uint8   PGA_input_ReadDataReg(void) ;
uint8   PGA_input_Read(void) ;
uint8   PGA_input_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PGA_input_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PGA_input_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PGA_input_DM_RES_UP          PIN_DM_RES_UP
#define PGA_input_DM_RES_DWN         PIN_DM_RES_DWN
#define PGA_input_DM_OD_LO           PIN_DM_OD_LO
#define PGA_input_DM_OD_HI           PIN_DM_OD_HI
#define PGA_input_DM_STRONG          PIN_DM_STRONG
#define PGA_input_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PGA_input_MASK               PGA_input__MASK
#define PGA_input_SHIFT              PGA_input__SHIFT
#define PGA_input_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PGA_input_PS                     (* (reg8 *) PGA_input__PS)
/* Data Register */
#define PGA_input_DR                     (* (reg8 *) PGA_input__DR)
/* Port Number */
#define PGA_input_PRT_NUM                (* (reg8 *) PGA_input__PRT) 
/* Connect to Analog Globals */                                                  
#define PGA_input_AG                     (* (reg8 *) PGA_input__AG)                       
/* Analog MUX bux enable */
#define PGA_input_AMUX                   (* (reg8 *) PGA_input__AMUX) 
/* Bidirectional Enable */                                                        
#define PGA_input_BIE                    (* (reg8 *) PGA_input__BIE)
/* Bit-mask for Aliased Register Access */
#define PGA_input_BIT_MASK               (* (reg8 *) PGA_input__BIT_MASK)
/* Bypass Enable */
#define PGA_input_BYP                    (* (reg8 *) PGA_input__BYP)
/* Port wide control signals */                                                   
#define PGA_input_CTL                    (* (reg8 *) PGA_input__CTL)
/* Drive Modes */
#define PGA_input_DM0                    (* (reg8 *) PGA_input__DM0) 
#define PGA_input_DM1                    (* (reg8 *) PGA_input__DM1)
#define PGA_input_DM2                    (* (reg8 *) PGA_input__DM2) 
/* Input Buffer Disable Override */
#define PGA_input_INP_DIS                (* (reg8 *) PGA_input__INP_DIS)
/* LCD Common or Segment Drive */
#define PGA_input_LCD_COM_SEG            (* (reg8 *) PGA_input__LCD_COM_SEG)
/* Enable Segment LCD */
#define PGA_input_LCD_EN                 (* (reg8 *) PGA_input__LCD_EN)
/* Slew Rate Control */
#define PGA_input_SLW                    (* (reg8 *) PGA_input__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PGA_input_PRTDSI__CAPS_SEL       (* (reg8 *) PGA_input__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PGA_input_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PGA_input__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PGA_input_PRTDSI__OE_SEL0        (* (reg8 *) PGA_input__PRTDSI__OE_SEL0) 
#define PGA_input_PRTDSI__OE_SEL1        (* (reg8 *) PGA_input__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PGA_input_PRTDSI__OUT_SEL0       (* (reg8 *) PGA_input__PRTDSI__OUT_SEL0) 
#define PGA_input_PRTDSI__OUT_SEL1       (* (reg8 *) PGA_input__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PGA_input_PRTDSI__SYNC_OUT       (* (reg8 *) PGA_input__PRTDSI__SYNC_OUT) 


#if defined(PGA_input__INTSTAT)  /* Interrupt Registers */

    #define PGA_input_INTSTAT                (* (reg8 *) PGA_input__INTSTAT)
    #define PGA_input_SNAP                   (* (reg8 *) PGA_input__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PGA_input_H */


/* [] END OF FILE */
