/*******************************************************************************
* File Name: PGA_ref.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_PGA_ref_H) /* Pins PGA_ref_H */
#define CY_PINS_PGA_ref_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PGA_ref_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PGA_ref_Write(uint8 value) ;
void    PGA_ref_SetDriveMode(uint8 mode) ;
uint8   PGA_ref_ReadDataReg(void) ;
uint8   PGA_ref_Read(void) ;
uint8   PGA_ref_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PGA_ref_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PGA_ref_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PGA_ref_DM_RES_UP          PIN_DM_RES_UP
#define PGA_ref_DM_RES_DWN         PIN_DM_RES_DWN
#define PGA_ref_DM_OD_LO           PIN_DM_OD_LO
#define PGA_ref_DM_OD_HI           PIN_DM_OD_HI
#define PGA_ref_DM_STRONG          PIN_DM_STRONG
#define PGA_ref_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PGA_ref_MASK               PGA_ref__MASK
#define PGA_ref_SHIFT              PGA_ref__SHIFT
#define PGA_ref_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PGA_ref_PS                     (* (reg8 *) PGA_ref__PS)
/* Data Register */
#define PGA_ref_DR                     (* (reg8 *) PGA_ref__DR)
/* Port Number */
#define PGA_ref_PRT_NUM                (* (reg8 *) PGA_ref__PRT) 
/* Connect to Analog Globals */                                                  
#define PGA_ref_AG                     (* (reg8 *) PGA_ref__AG)                       
/* Analog MUX bux enable */
#define PGA_ref_AMUX                   (* (reg8 *) PGA_ref__AMUX) 
/* Bidirectional Enable */                                                        
#define PGA_ref_BIE                    (* (reg8 *) PGA_ref__BIE)
/* Bit-mask for Aliased Register Access */
#define PGA_ref_BIT_MASK               (* (reg8 *) PGA_ref__BIT_MASK)
/* Bypass Enable */
#define PGA_ref_BYP                    (* (reg8 *) PGA_ref__BYP)
/* Port wide control signals */                                                   
#define PGA_ref_CTL                    (* (reg8 *) PGA_ref__CTL)
/* Drive Modes */
#define PGA_ref_DM0                    (* (reg8 *) PGA_ref__DM0) 
#define PGA_ref_DM1                    (* (reg8 *) PGA_ref__DM1)
#define PGA_ref_DM2                    (* (reg8 *) PGA_ref__DM2) 
/* Input Buffer Disable Override */
#define PGA_ref_INP_DIS                (* (reg8 *) PGA_ref__INP_DIS)
/* LCD Common or Segment Drive */
#define PGA_ref_LCD_COM_SEG            (* (reg8 *) PGA_ref__LCD_COM_SEG)
/* Enable Segment LCD */
#define PGA_ref_LCD_EN                 (* (reg8 *) PGA_ref__LCD_EN)
/* Slew Rate Control */
#define PGA_ref_SLW                    (* (reg8 *) PGA_ref__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PGA_ref_PRTDSI__CAPS_SEL       (* (reg8 *) PGA_ref__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PGA_ref_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PGA_ref__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PGA_ref_PRTDSI__OE_SEL0        (* (reg8 *) PGA_ref__PRTDSI__OE_SEL0) 
#define PGA_ref_PRTDSI__OE_SEL1        (* (reg8 *) PGA_ref__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PGA_ref_PRTDSI__OUT_SEL0       (* (reg8 *) PGA_ref__PRTDSI__OUT_SEL0) 
#define PGA_ref_PRTDSI__OUT_SEL1       (* (reg8 *) PGA_ref__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PGA_ref_PRTDSI__SYNC_OUT       (* (reg8 *) PGA_ref__PRTDSI__SYNC_OUT) 


#if defined(PGA_ref__INTSTAT)  /* Interrupt Registers */

    #define PGA_ref_INTSTAT                (* (reg8 *) PGA_ref__INTSTAT)
    #define PGA_ref_SNAP                   (* (reg8 *) PGA_ref__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PGA_ref_H */


/* [] END OF FILE */
