/* ========================================
 *
 * Copyright BARC, 2013
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <device.h>
#include "PGA.h"


uint8 sel;	// variable for gain selection


void main()
{
    /*-----initialization of hardware-----*/
	
	PGA_Start();
	OPAmp_Start();
	LCD_test_Start();
	
	Opamp_1_Start();
	Opamp_2_Start();
	
	Opamp_3_Start();
	
	
	USBUART_Start(0, USBUART_5V_OPERATION); // important to specify the supply of USB 
											// for USB device to be recognized
	
	/*-----------------------------------*/
	CyGlobalIntEnable;  /* enable global interrupts. */
	
	/*---display on LCD project name---*/
			LCD_test_PrintString("PSoc PGA:1i/2o");
	/*---------------------------------*/
	
	while(!USBUART_GetConfiguration()); 	// imp: enable global interrupts before getting configuration, 
											// USB device will not be recognized otherwise
	
	USBUART_CDC_Init();
	
	
	/*---Delay for hyperterminal to setup---*/
	PGA_SetPower(PGA_MEDPOWER);
	
	
	for(;;)
    {
					
	
		while (!USBUART_DataIsReady());	// wait while a selection is made by user
			
		/*selection among gain values*/
		
		sel= USBUART_GetChar();
		
		switch (sel)
		{ 
			
			case'2':
			PGA_SetGain(PGA_GAIN_02);
			USBUART_PutString("2 times voltage \n");
			break;
			
			case'3':
			PGA_SetGain(PGA_GAIN_08);
			USBUART_PutString("8 times voltage \n");
			break;
			
			case'4':
			PGA_SetGain(PGA_GAIN_16);
			USBUART_PutString("16 times voltage \n");
			break;
						
			case'5':
			PGA_SetGain(PGA_GAIN_24);
			USBUART_PutString("24 times voltage \n");
			break;
			
			
//			case'4':
//			PGA_SetGain(PGA_GAIN_50);
//			USBUART_PutString("50 times voltage");// commented because saturating the output
			
			case'1': default:
			PGA_SetGain(PGA_GAIN_01);
			USBUART_PutString("Buffer: unity gain \n");
			break;
		
		}
		
	}
}

/* [] END OF FILE */
